import $http from "./http";
// 区域标签树
export function getRoomTree() {
  return $http({
    method: "get",
    url: "/admin/label/tree?scene=meeting_room_location"
  });
}

// 获取预定会议室列表
export function getReserveRoomList(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: "/meet/meeting-room/queryMeetingRoomAndOccupyTimeSlot"
  });
}

// 获取首页信息
export function getHomeUserSchedule(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/meet/schedule/getHomeUserSchedule`
  });
}

/* 创建日程全部请求 */

// 创建日程
export function addSchedule(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/meet/schedule/addSchedule`
  });
}
// 获取参会会人员的日程
export function getUserScheduleInTime(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/meet/schedule/getUserScheduleInTime`
  });
}
// 获取日程详情
export function getScheduleDetail(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/meet/schedule/getScheduleDetail`
  });
}
// 文件上传
export function uploadPermissions(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/admin/ddOpenApi/getCustomSpaceAndGrantCustomSpace`
  });
}
// 文件预览
export function previewPermissions(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/admin/ddOpenApi/getCustomSpaceAndGrantCustomSpace`
  });
}
// 编辑日程
export function modifySchedule(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/meet/schedule/modifySchedule`
  });
}
// 删除日程
export function deleteSchedule(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/meet/schedule/deleteSchedule`
  });
}
// 可用会议室列表
export function queryAvailableMeetingRoomByTime(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/meet/meeting-room/queryAvailableMeetingRoomByTime`
  });
}
// 跨天会议判断是否可点击
export function getAllScheduleWithMeetingRoomByTime(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/meet/meeting-room/getAllScheduleWithMeetingRoomByTime`
  });
}
// 获取动态展示
export function getDynamic(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/meet/meeting-log/list`
  });
}
// 获取动态展示
export function saveFileInfo(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/meet/meeting-log-resource/save`
  });
}
// 删除文件
export function delFile(data) {
  return $http({
    method: "get",
    url: `/meet/schedule-accessory/remove/${data}`
  });
}
// 编辑文件
export function editFile(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/meet/schedule-accessory/update`
  });
}
// 参加 不参加
export function isParticipate(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/meet/schedule/confirm`
  });
}
//会议室详情的获取重复会议动态列表
export function getMeetingRoomRepeatAffairs(groupId, page) {
  return $http({
    method: "get",
    url: `/meet/meeting-log/scheduleTemplateMeetingLogPage?groupId=${groupId}&size=10&current=${page}`
  });
}
//会议室详情的获取动态列表
export function getMeetingRoomAffairs(id) {
  return $http({
    method: "get",
    url: `/meet/comment/listByMeetingId?meetingId=${id}&platform=dingTalk`
  });
}
//会议室创建新任务
export function createMeetingTask(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/meet/meeting-log-resource/save`
  });
}
//会议室修改任务
export function updateMeetingTask(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/meet/comment/handler`
  });
}
// 修改动态
export function updateMoment(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: '/meet/comment/modify'
  })
}
// 删除动态
export function deleteMoment(id) {
  return $http({
    method: 'get',
    url: `/meet/comment/remove?commentId=${id}`
  })
}
//删除任务
export function deleteMeetingTask(id) {
  return $http({
    method: "get",
    url: `/meet/meeting-log-resource/remove/${id}`
  });
}
// 测试的首页api
export function getHomeUserSchedule1(data) {
  return $http({
    method: "POST",
    data: JSON.stringify(data),
    url: "/meet/schedule/getHomeUserSchedule1"
  });
}

// 动态list
export function getDynamicList(data) {
  return $http({
    method: "get",
    data: data,
    url: `/meet/comment/list`
  });
}

// 我的动态会议置顶
export function meetingCollection(data) {
  return $http({
    method: "POST",
    data: JSON.stringify(data),
    url: "/meet/schedule/collection"
  });
}
// 获取outlook页面授权地址
export function getOutlookUrl(data) {
  return $http({
    method: "POST",
    data: "",
    url: `/microsoft/getThirdLoginUrl?state=${data}`,
    type: "binding"
  });
}

// 获取绑定的app
export function getThirdUserPlatForm(data) {
  return $http({
    method: "get",
    data: data,
    url: `/admin/third/user/getThirdUserPlatForm`
  });
}

// 解绑第三方app
export function unbindingApp(data) {
  return $http({
    method: "get",
    data: "",
    url: `/admin/third/user/remove/${data}`
  });
}
// 获取zoom授权页面
export function getZoomUrl(data) {
  return $http({
    method: "get",
    data: "",
    url: `/zoom/auth?orgId=${data.orgId}&userId=${data.userId}`,
    type: "binding"
  });
}
// oss 上传 获取授权
export function getOssPermission() {
  return $http({
    method: "get",
    data: "",
    url: `/meet/meeting-log-resource/getOssUploadSignature`
  });
}
// oss 上传 获取授权
export function getuploadResource(data) {
  return $http({
    method: "post",
    data: JSON.stringify(data),
    url: `/meet/meeting-log-resource/uploadResource`
  });
}
// oss 预览
export function previewOss(data) {
  return $http({
    method: "get",
    url: `/meet/meeting-log-resource/generateIDocViewFileUrl?fileId=${data}`
  });
}
// 根据id 换取 会议室
export function getDeviceBySn(data) {
  return $http({
    method: "get",
    url: `/meet/meeting-room-device/getDeviceBySn?deviceSn=${data}`
  });
}
export function setRead(meetingId) {
  return $http({
    method: 'get',
    url: `/meet/comment/read?meetingId=${meetingId}&platform=dingTalk`
  })
}

export function previewOssFile(data) {
  return $http({
    method: 'post',
    url: `/meet/fileDetail`,
    data: JSON.stringify(data)
  })
}