import create from 'dd-store';
import { checkFullScren } from "../../utils/checkFullScren";
import pageStore from './store';
import { saveFileInfo, getMeetingRoomAffairs, createMeetingTask, deleteMeetingTask, updateMeetingTask, uploadPermissions } from '../../api/request';
import { getOssPermission, getuploadResource, isParticipate, deleteSchedule, getScheduleDetail, getUserScheduleInTime, modifySchedule, getMeetingRoomRepeatAffairs, updateMoment, deleteMoment, setRead } from '../../api/request.js'
import { selectedelRequired, selectPeople, getShowTime, modifyTimeImpactRepeat, throttle, getCreateShowTime, dealRepeatModal, removeHtml } from './../../utils/utils.js'
import { observer } from '/utils/observer.js'
import { resolve } from 'path';
import { getFileInfo, aheadTimesList, getFileInfoFromOss } from './uploadFile.js';
import { repeatList } from '../createMeeting/constant';
import { delSheudleList, aheadTimeList, participateStatusList, noParticipateStatusList, centerPopupList, editSaveList } from './constant';
import { getSelectRepeatId, getInitialPsarticipants, handleChangePeople } from './utils'
create.Page({
  store: pageStore,
  useAll: true,
  data: {
    current: 1,
    pages: 1,
    isIPX: false,
    $data: null,
    affairLoading: true,
    affairList: null, //store,页面用到的变量需要在这里声明

    loading: {
      details: true,
      dynamic: true
    },
    title: ``,
    meetingRemark: '',
    isShowRemark: false,
    showTime: '',
    repeat: {
      repeatList: repeatList,
      recurrenceModel: { model: 'no_repeat' },
      repeatable: 0,
      selectRepeatId: 0
    },
    popup: {
      show: false,
      title: '',
      mask: '',
      type: 'modify_location'
    },
    organizer: '',
    currentPeople: '',
    scheduleItem: '',
    isExpand: false,
    confirmAttendance: null,
    aheadTime: {
      aheadTimeList: aheadTimeList,
      aheadTimes: [15],
      iconType: 'icon',
      aheadTimesListId: [15],
    },
    selectPopup: {
      show: false,
      list: participateStatusList,
      type: ''
    },
    centerPopup: {
      show: false,
      list: centerPopupList,
      type: 'modify_location'
    },
    needNotice: 0,
    placeholder: '',
    id: '',
    saveLoading: false
  },
  onShow() {
    console.log('onshow')
    this.update()
    if (this.store.data.isNeedReloadList) {
      this.store.data.isNeedReloadList = false
      this.loadAffairList();
      this.$store.data.isIndexAffairListNeedUpdate = true;
      this.update();
    }

    // 告诉首页要刷新数据
    if (this.store.data.isNeedReloadIndexList) {
      this.store.data.isNeedReloadIndexList = false
      this.$store.data.isIndexAffairListNeedUpdate = true;
      this.update();
    }
    // 修改地点 或者 参会人保存
    if (this.$store.data.updateInfo.isUpate) {
      if (this.$store.data.updateInfo.updateType === "modify_location") {
        this.setData({
          'centerPopup.show': true,
          'centerPopup.type': "modify_location"
        })
      }
      if (this.$store.data.updateInfo.updateType === 'operate_user') {
        this.setData({
          'centerPopup.show': true,
          'centerPopup.type': "operate_user"
        })
      }
      this.$store.data.updateInfo = {
        updateType: '',
        isUpate: false
      }
      this.update()
    }
    if (this.$store.data.shouldUpdateShowTime) {
      this.setData({
        showTime: getShowTime(this.$store.data.startTime, this.$store.data.endTime)
      })
      this.$store.data.shouldUpdateShowTime = false;
      this.update();
    }

  },
  onLoad(event) {
    console.log('onload')
    const scheduleItem = JSON.parse(decodeURIComponent(event.scheduleItem));
    this.reset()
    this.setData({
      isIPX: checkFullScren(),
      placeholder: `${getApp().globalData.name}创建的会议`,
      scheduleItem,
      currentPeople: getApp().globalData.userid || dd.getStorageSync({ key: 'userid' }).data
    })
    this.getDetail();
    const _that = this
    observer.register({
      notice(scheduleItem) {
        _that.setData({
          'scheduleItem.scheduleTemplateId': scheduleItem
        })
      }
    })


  },
  // 获取详情
  getDetail() {
    let data = {
      id: !!this.data.scheduleItem.scheduleId ? this.data.scheduleItem.scheduleId : this.data.scheduleItem.id,
      scheduleTemplateId: this.data.scheduleItem.scheduleTemplateId,
      planDate: !!this.data.scheduleItem.planDate ? this.data.scheduleItem.planDate.replace(/\//g, '-') : null
    }
    //动态列表进来的详情传groupId
    if (this.data.scheduleItem.groupId) {
      data.groupId = this.data.scheduleItem.groupId;
      delete data.id;
      delete data.planDate;
    }
    getScheduleDetail(data).then(res => {
      if (res.data.code !== 0) {
        return
      }
      if (!res.data.data.id) {
        console.log('详情接口scheduleId不存在')
        return
      }


      this.setData({
        scheduleItem: {
          id: res.data.data.id,
          scheduleTemplateId: res.data.data.scheduleTemplateId,
          planDate: res.data.data.planDate,
        },
        title: res.data.data.title,
        mrReserveStatus: res.data.data.mrReserveStatus,
        meetingRemark: res.data.data.remark,
        isShowRemark: res.data.data.remark ? true : false,
        showTime: getShowTime(res.data.data.startTime.replace(/-/g, "/"), res.data.data.endTime.replace(/-/g, "/")),
        repeat: {
          repeatable: res.data.data.repeatable,
          repeatList: repeatList,
          recurrenceModel: res.data.data.repeatable ? res.data.data.recurrenceModel : { model: 'no_repeat' },
          selectRepeatId: res.data.data.repeatable === 0 ? 0 : getSelectRepeatId(res.data.data.recurrenceModel, repeatList)
        },
        organizer: res.data.data.organizer.split("::")[0],
        isExpand: res.data.data.confirmAttendance === 1 ? true : false,
        confirmAttendance: res.data.data.confirmAttendance === null ? -9 : res.data.data.confirmAttendance,
        aheadTime: {
          aheadTimeList: aheadTimeList,
          aheadTimes: !!res.data.data.aheadTimes ? res.data.data.aheadTimes : [],
          iconType: 'icon',
          aheadTimesListId: !!res.data.data.aheadTimes ? res.data.data.aheadTimes : [-1],
        },
        "loading.details": false
      })

      this.$store.data.originalData = res.data.data;
      if (res.data.data.location) {
        this.$store.data.locationName = res.data.data.location.meetingRoomName || res.data.data.location.locationName;
      }
      this.$store.data.roomId = res.data.data.meetingRoomId < 0 ? '' : res.data.data.meetingRoomId
      this.store.data.scheduleId = res.data.data.groupId
      this.$store.data.startTime = res.data.data.startTime.replace(/-/g, "/")
      this.$store.data.endTime = res.data.data.endTime.replace(/-/g, "/")
      this.$store.data.participatorList = getInitialPsarticipants(res.data.data.userList)
      this.$store.data.showParticipatorList = Object.values(this.$store.data.participatorList)
      this.$store.data.originUsers = [...this.$store.data.showParticipatorList]

      this.update()
      this.loadAffairList(res.data.data.groupId);
    })
  },

  // 添加标题
  handleChangeTitle(event) {
    this.setData({
      title: event.detail.value
    })
  },
  // 保存标题
  handleTitleSave() {
    const modifyModel = "only"
    let dataTitle = {
      title: this.data.title,
      modifyModel: modifyModel,
      modifyContent: 'title'
    }
    if (this.data.repeat.repeatable) {
      dataTitle.modifyModel = "future"
    }
    this.modifySchedule(dataTitle).then(res => {
      if (res.data.code !== 0) {
        this.setData({
          title: this.$store.data.originalData.title
        })
        return
      }
      this.$store.data.originalData.title = this.data.title
      this.$store.data.isIndexAffairListNeedUpdate = true;

      this.update()
    })
  },


  // 打开添加描述
  handleOpenRemark() {
    this.setData({
      isShowRemark: true
    })
  },
  // 添加描述
  handleChangeRemark(event) {
    this.setData({
      meetingRemark: event.detail.value
    })
  },
  // 保存添加描述
  handleRemarkSave() {
    const modifyModel = "only"
    let dataRemark = {
      remark: this.data.meetingRemark,
      modifyModel: modifyModel,
      modifyContent: 'remark'
    }
    if (this.data.repeat.repeatable) {
      dataRemark.modifyModel = "future"
    }
    this.modifySchedule(dataRemark).then(res => {
      if (res.data.code !== 0) {
        this.setData({
          remark: this.$store.data.originUsers.remark
        })
        return
      }
      this.$store.data.originUsers.remark = this.data.remark
      this.update()
    })

  },


  // 跳转选择地点
  goSelectPlace() {
    dd.navigateTo({
      url: `./../place/place?scheduleItem=${encodeURIComponent(JSON.stringify(this.data.scheduleItem))}`
    })
  },
  // 删除地点
  handleDeletePlace() {
    this.$store.data.locationName = ''
    this.$store.data.roomId = ''
    this.update()
    this.setData({
      'centerPopup.show': true,
      'centerPopup.type': "modify_location"
    })
  },

  // 选择地点是否发送通知
  selectPlaceNeedNotice(event) {
    this.handleCloseCenterPopup()
    const needNotice = event.currentTarget.dataset.item.id
    if (this.data.repeat.repeatable == 0) {
      this.handlePlaceSave('only', needNotice)
      return
    }
    this.setData({
      needNotice: needNotice,
      selectPopup: {
        show: true,
        list: editSaveList,
        type: 'modify_location'
      }
    })
  },
  // 地点 保存此次还是以后
  selectSavePlaceStatus(event) {
    this.handleSelectPopupCancel()
    const modifyModel = event.currentTarget.dataset.item.id
    this.handlePlaceSave(modifyModel, this.data.needNotice)
  },
  // 保存地点
  handlePlaceSave(modifyModel = "only", needNotice = "N") {
    let dataLocation = {
      modifyModel: modifyModel,
      needNotice: needNotice,
      modifyContent: 'modify_location',
      location: {
        longitude: '-999',
        latitude: '-999',
        meetingRoomName: this.$store.data.locationName
      },
      meetingRoomId: !!this.$store.data.roomId ? this.$store.data.roomId : -1
    }
    this.modifySchedule(dataLocation).then(res => {
      this.$store.data.updateInfo = {
        updateType: '',
        isUpate: false
      }
      if (res.data.code !== 0) {
        this.reSetPlace()
        return
      }
      this.$store.data.originalData.location = {
        latitude: "-999",
        locationName: this.$store.data.locationName,
        longitude: '-999'
      }
      this.$store.data.originalData.meetingRoomId = this.$store.data.roomId
      this.update()
    })
  },
  // 取消修改地点
  handleSelectPopupPlaceCancel() {
    this.setData({
      selectPopup: {
        show: false,
        list: "",
        type: ""
      }
    })
    this.reSetPlace()
  },
  //重置地点
  reSetPlace() {
    this.$store.data.locationName = this.$store.data.originalData.location.locationName
    this.$store.data.roomId = this.$store.data.originalData.meetingRoomId < 0 ? "" : this.$store.data.originalData.meetingRoomId
    this.update()
  },




  // 选择时间 打开popup
  handleTime() {
    this.setData({
      popup: {
        show: true,
        title: "选择会议时间",
        mask: true,
        type: 'time'
      }
    })
  },
  // 选择时间点击完成
  onComplete(event) {
    this.$store.data.startTime = `${event.startTime}:00`
    this.$store.data.endTime = `${event.endTime}:00`
    this.update()
    this.setData({
      showTime: getShowTime(this.$store.data.startTime, this.$store.data.endTime)
    })
    this.closePopup()
    this.setData({
      'centerPopup.show': true,
      'centerPopup.type': "modify_time"
    })

  },
  // 选择时间是否发送通知
  selectTimeNeedNotice(event) {
    this.handleCloseCenterPopup()
    const needNotice = event.currentTarget.dataset.item.id
    if (this.data.repeat.repeatable == 0) {
      this.handleTimeSave('only', needNotice)
      return
    }
    this.setData({
      needNotice: needNotice,
      selectPopup: {
        show: true,
        list: editSaveList,
        type: 'modify_time'
      }
    })
  },
  // 时间 保存此次还是以后
  selectSaveTimeStatus(event) {
    this.handleSelectPopupCancel()
    const modifyModel = event.currentTarget.dataset.item.id
    this.handleTimeSave(modifyModel, this.data.needNotice)
  },
  // 保存时间
  handleTimeSave(modifyModel = "only", needNotice = "N") {
    let data = {
      needNotice: needNotice,
      modifyModel: modifyModel,
      startTime: this.$store.data.startTime.replace(/\//g, "-"),
      endTime: this.$store.data.endTime.replace(/\//g, "-"),
      modifyContent: 'modify_time'
    }
    this.modifySchedule(data).then(res => {
      if (res.data.code !== 0) {
        this.resetTime()
        return
      }
      /* 
   改时间 改掉重复规则
   先选重复规则 再改时间 重复规则也要改变
   暂时修改每周 每月重复问题
    */
      if (this.data.repeat.repeatable !== 0) {
        let recurrenceModel = modifyTimeImpactRepeat(this.data.repeat.recurrenceModel)
        this.setData({
          'repeat.recurrenceModel': recurrenceModel
        })
        this.handleRepeatSave(data.modifyModel, data.needNotice)

      }
      this.$store.data.originalData.startTime = this.$store.data.startTime
      this.$store.data.originalData.endTime = this.$store.data.endTime
      this.update()
    })
  },
  // 取消修改时间
  handleSelectPopupTimeCancel() {
    this.handleSelectPopupCancel()
    this.resetTime()
  },
  // 重置时间
  resetTime() {

    this.$store.data.startTime = this.$store.data.originalData.startTime.replace(/-/g, "/")
    this.$store.data.endTime = this.$store.data.originalData.endTime.replace(/-/g, "/")
    this.update()
  },

  // 选择重复规则 打开popup
  handleRepeatModal() {
    this.setData({
      popup: {
        show: true,
        title: "重复规则",
        mask: true,
        type: 'repeat'
      }
    })
  },

  // 选择重复
  selectRepeatListItem(event) {
    const item = event.currentTarget.dataset.item
    const repeat = dealRepeatModal(item)
    this.setData({
      'repeat.repeatable': repeat.repeatable,
      'repeat.recurrenceModel': repeat.recurrenceModel,
      'repeat.selectRepeatId': repeat.selectRepeatId,
    })
    this.closePopup()
    this.setData({
      'centerPopup.show': true,
      'centerPopup.type': "repeat"
    })
  },
  // 重复 发不发通知
  selectRepeatNeedNotice(event) {
    this.handleCloseCenterPopup()
    const needNotice = event.currentTarget.dataset.item.id
    if (this.$store.data.originalData.repeatable === 0) {
      this.handleRepeatSave('only', needNotice)
      return
    }
    this.setData({
      needNotice: needNotice,
      selectPopup: {
        show: true,
        list: editSaveList,
        type: 'repeat'
      }
    })
  },
  // 保存此次还是以后
  selectSaveRepeatStatus(event) {
    this.handleSelectPopupCancel()
    const modifyModel = event.currentTarget.dataset.item.id
    this.handleRepeatSave(modifyModel, this.data.needNotice)
  },
  //保存重复
  handleRepeatSave(modifyModel = "only", needNotice = "N") {
    let modifyContent = 'to_repeat'
    if (this.$store.data.originalData.repeatable === 0 && this.data.repeat.repeatable === 1) {
      modifyContent = 'to_repeat'
    }
    else if (this.$store.data.originalData.repeatable === 1 && this.data.repeat.repeatable === 0) {
      modifyContent = "no_repeat"
    }
    else {
      modifyContent = "change_rule"
    }
    let dataRepeat = {
      needNotice: needNotice,
      startTime: this.$store.data.startTime.replace(/\//g, "-"),
      endTime: this.$store.data.endTime.replace(/\//g, "-"),
      modifyModel: modifyModel,
      modifyContent: modifyContent,
      recurrenceModel: this.data.repeat.recurrenceModel,
      repeatable: this.data.repeat.repeatable
    }
    this.modifySchedule(dataRepeat).then(res => {
      if (res.data.code !== 0) {
        this.reSetRepeat()
        return
      }
      this.$store.data.originalData.repeatable = this.data.repeat.repeatable
      this.$store.data.originalData.recurrenceModel = this.data.repeat.recurrenceModel
      this.update()
    })
  },
  // 重置重复规则
  reSetRepeat() {
    this.setData({
      repeat: {
        repeatable: this.$store.data.originalData.repeatable,
        repeatList: repeatList,
        recurrenceModel: this.$store.data.originalData.repeatable ? this.$store.data.originalData : { model: 'no_repeat' },
        selectRepeatId: this.$store.data.originalData.repeatable === 0 ? 0 : getSelectRepeatId(this.$store.data.originalData.recurrenceModel, repeatList)
      }
    })
  },

  // 添加参会人
  handleAddParticipator: throttle(async function () {
    let select = []
    let require = []
    if (this.data.organizer === this.data.currentPeople) {
      select = Object.keys(this.$store.data.participatorList)
      require = [this.data.currentPeople]
      select = selectedelRequired(select, require)
    } else {
      select = []
      require = Object.keys(this.$store.data.participatorList)
    }

    const showParticipatorList = this.$store.data.showParticipatorList
    selectPeople(select, require).then(res => {
      let participatorList = {}
      if (this.data.organizer === this.data.currentPeople) {
        participatorList[getApp().globalData.userid] = {
          userId: getApp().globalData.userid, username: getApp().globalData.name, headUrl: getApp().globalData.avatar, platform: 'dingtalk', confirmAttendance: this.data.confirmAttendance
        }
      }

      if (this.data.organizer !== this.data.currentPeople) {
        for (let i = 0; i < this.$store.data.showParticipatorList.length; i++) {
          participatorList[showParticipatorList[i].userId] = { userId: showParticipatorList[i].userId, username: showParticipatorList[i].username, headUrl: showParticipatorList[i].headUrl, platform: 'dingtalk' }
        }
      }

      for (let i = 0; i < res.users.length; i++) {
        participatorList[res.users[i].userId] = { userId: res.users[i].userId, username: res.users[i].name, headUrl: res.users[i].avatar, platform: 'dingtalk' }
      }
      this.$store.data.participatorList = participatorList
      this.$store.data.showParticipatorList = Object.values(participatorList)
      this.update()
      this.setData({
        'centerPopup.show': true,
        'centerPopup.type': "operate_user"
      })
      // this.handleParticipatorSave()
    })
  }),
  // 保存参会人是否发送通知
  selectPeopleNeedNotice(event) {
    this.handleCloseCenterPopup()
    const needNotice = event.currentTarget.dataset.item.id
    if (this.data.repeat.repeatable == 0) {
      this.handleParticipatorSave('only', needNotice)
      return
    }
    this.setData({
      needNotice: needNotice,
      selectPopup: {
        show: true,
        list: editSaveList,
        type: 'operate_user'
      }
    })
  },
  //保存此次还是以后
  selectSavePeopleStatus(event) {
    this.handleSelectPopupCancel()
    const modifyModel = event.currentTarget.dataset.item.id
    this.handleParticipatorSave(modifyModel, this.data.needNotice)
  },
  //保存参会人
  handleParticipatorSave(modifyModel = "only", needNotice = "N") {
    const changePeople = handleChangePeople(this.$store.data.originUsers, this.$store.data.showParticipatorList)
    let dataUser = {
      addUserList: changePeople.add,
      deleteUserList: changePeople.del,
      modifyModel: modifyModel,
      modifyContent: 'operate_user'
    }
    this.modifySchedule(dataUser).then(res => {
      if (res.data.code !== 0) {
        this.resetPeople()
        return
      }
      this.$store.data.originUsers = Object.values(this.$store.data.participatorList)
    })
  },
  // 取消参会人的保存
  handleSelectPopupPeopleCancel() {
    this.handleSelectPopupCancel()
    this.resetPeople()
  },
  // 重置参会人
  resetPeople() {
    const originUsers = this.$store.data.originUsers
    let people = {}
    for (let i = 0; i < originUsers.length; i++) {
      people[originUsers[i].userId] = originUsers[i]
    }
    this.$store.data.participatorList = people
    this.$store.data.showParticipatorList = Object.values(this.$store.data.participatorList)
    this.update()
  },
  // 参会人详情
  goParticipantsDetail() {
    dd.navigateTo({ url: `./../participantsDetail/participantsDetail?scheduleItem=${this.store.data.scheduleItem}&organizer=${this.data.organizer}&confirmAttendance=${this.data.confirmAttendance}` })
  },


  // 保存编辑
  modifySchedule(data) {
    let that = this
    let obj = {
      scheduleId: this.data.scheduleItem.id,
      templateId: this.data.scheduleItem.scheduleTemplateId,
      planDate: this.data.scheduleItem.planDate
    }
    return new Promise((resolve) => {
      modifySchedule(Object.assign(data, obj)).then(res => {
        if (res.data.code !== 0) {
          dd.alert({
            content: '保存失败'
          })
          return
        }
        if (this.$store.modifyErpeatMeeting) {
          this.$store.modifyErpeatMeeting();

        }
        if (this.data.repeat.repeatable === 1 && !!res.data.data) {
          observer.notice(res.data.data)
        }
        resolve(res)
      })

    })

  },

  // 删除 日程
  handleDelete() {
    const _that = this
    if (this.data.repeat.repeatable === 0) {
      dd.confirm({
        title: '删除会议',
        content: '确认删除会议吗？',
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        success: (success) => {
          if (!!success.confirm) {
            _that.deleteSave("only")
          }
        }
      })
    } else {
      this.setData({
        selectPopup: {
          show: true,
          list: delSheudleList,
          type: "deleteState"
        }
      })
    }
  },
  // 删除此次还是以后
  selectDeleteStatus(event) {
    this.handleSelectPopupCancel()
    const modifyModel = event.currentTarget.dataset.item.id
    this.deleteSave(modifyModel)

  },
  // 删除
  deleteSave(modifyModel = "only") {
    dd.showLoading({
      content: '正在删除...',
    });
    let data = {
      scheduleId: this.data.scheduleItem.id,
      identify: this.data.organizer === getApp().globalData.userid ? 'major' : 'identify',
      deleteModel: modifyModel,
      templateId: this.data.scheduleItem.scheduleTemplateId,
      planDate: this.data.scheduleItem.planDate
    }
    deleteSchedule(data).then(async () => {
      if (this.$store.modifyErpeatMeeting) {
        await this.$store.modifyErpeatMeeting()
      }
      this.$store.data.isIndexAffairListNeedUpdate = true;
      this.update()
      dd.hideLoading()
      dd.navigateBack({
        delta: 1
      })
    })

  },


  //选择会前题醒打开popup
  handleAheadTime() {
    this.setData({
      popup: {
        show: true,
        title: "会前提醒",
        mask: true,
        type: 'aheadTime'
      }
    })
  },
  handleAheadTimeSave(event) {
    this.closePopup()
    this.setData({
      'aheadTime.aheadTimes': event,
      'aheadTime.aheadTimesListId': event,
    })
    let modifyModel = "only"
    if (this.data.repeat.repeatable !== 0) {
      modifyModel = "all"
    }
    let dataAheadTime = {
      modifyModel: modifyModel,
      aheadTimes: this.data.aheadTime.aheadTimes,
      modifyContent: 'aheadTimes'
    }
    this.modifySchedule(dataAheadTime)
  },

  // 点击参加
  handleParticipate() {
    let dataParticipate = {
      scheduleId: this.data.scheduleItem.id,
      value: 1,
      type: 'only'
    }
    if (this.data.repeat.repeatable !== 0) {
      this.setData({
        selectPopup: {
          show: true,
          list: participateStatusList,
          type: "participateState"
        }
      })
      return
    }
    this.participateSave(dataParticipate)
  },
  // 点击 不参加
  handleNoParticipate() {
    let dataNoParticipate = {
      scheduleId: this.data.scheduleItem.id,
      value: 0,
      type: 'only'
    }
    if (this.data.repeat.repeatable !== 0) {
      this.setData({
        selectPopup: {
          show: true,
          list: noParticipateStatusList,
          type: "participateState"
        }
      })
      return
    }
    this.participateSave(dataNoParticipate)
  },
  // 重复 选择参加 不参加
  selectParticipateStatus(event) {
    this.handleSelectPopupCancel()
    const item = event.currentTarget.dataset.item
    let dataParticipate = {
      scheduleId: this.data.scheduleItem.id,
      type: item.id,
      templateId: this.data.scheduleItem.scheduleTemplateId,
      planDate: this.data.scheduleItem.planDate,
      value: item.value
    }
    this.participateSave(dataParticipate)
  },
  // 回到初始状态
  initialState() {
    let data = {
      templateId: this.data.scheduleItem.scheduleTemplateId,
      planDate: this.data.scheduleItem.planDate,
      scheduleId: this.data.scheduleItem.id,
      value: -9,
      type: 'only'
    }
    if (this.data.repeat.repeatable === 1) {
      data.type = 'all'
    }

    isParticipate(data).then(res => {
      if (res.data.code !== 0) {
        console.log(res)
        return
      }
      this.setData({
        confirmAttendance: -9
      })
      this.$store.data.participatorList[this.data.currentPeople].confirmAttendance = -9
      this.$store.data.showParticipatorList = Object.values(this.$store.data.participatorList)
      this.$store.data.originUsers = [...this.$store.data.showParticipatorList]
      this.update()
      if (this.data.repeat.repeatable === 1) {
        if (this.$store.modifyErpeatMeeting) {
          this.$store.modifyErpeatMeeting()
        }
        return
      }
      if (this.$store.modifyOnceMeetingContent) {
        this.$store.modifyOnceMeetingContent({ id: this.data.scheduleItem.id, confirmAttendance: -9 })
      }
    })
  },
  // 参加状态保存 
  participateSave(dataParticipate) {
    const _that = this
    return new Promise((resolve) => {
      isParticipate(dataParticipate).then(res => {
        resolve(res)
        if (res.data.code !== 0) {
          return
        }
        // if (_that.data.currentPeople === _that.data.organizer) {
        //   _that.setData({
        //     'aheadTime.aheadTimes': [15],
        //     'aheadTime.aheadTimesListId': [15],
        //   })
        // }
        _that.setData({
          confirmAttendance: dataParticipate.value
        })
        _that.$store.data.participatorList[_that.data.currentPeople].confirmAttendance = dataParticipate.value
        _that.$store.data.showParticipatorList = Object.values(_that.$store.data.participatorList)
        _that.$store.data.originUsers = [..._that.$store.data.showParticipatorList]
        _that.update()


        if (dataParticipate.type === "only") {
          if (_that.$store.modifyOnceMeetingContent) {
            _that.$store.modifyOnceMeetingContent({ id: this.data.scheduleItem.id, confirmAttendance: dataParticipate.value })
          }
          return
        }
        if (_that.$store.modifyErpeatMeeting) {
          _that.$store.modifyErpeatMeeting()
        }
      })

    })
  },

  // 关闭handleSelectPopupCancel
  handleSelectPopupCancel() {
    this.setData({
      selectPopup: {
        show: false,
        list: "",
        type: ""
      }
    })
  },
  // 关闭popup
  closePopup() {
    this.setData({
      popup: {
        show: false,
        title: "",
        mask: true,
        type: ''
      }
    })
  },
  // 关闭centerPopup
  handleCloseCenterPopup() {
    this.setData({
      centerPopup: {
        show: false,
        list: centerPopupList,
        type: ''
      }
    })
  },

  // 初始化
  reset() {
    this.$store.resetEditData()
    this.store.data.affairList = [];
    this.handleCloseOperation()
  },

  // 页面卸载
  onUnload() {
    // 页面被关闭
    observer.unregister()
  },

  //获取动态列表
  loadAffairList(id) {
    if (!id) {
      id = this.store.data.scheduleId;
    }
    this.getAffairList(id)
  },
  //获取单次会议动态列表
  getAffairList(id) {
    getMeetingRoomAffairs(id).then(res => {
      this.getTaskAndFiles(res.data.data);
      const [newAffairList, separate] = this.dealAffairData(res.data.data || []);
      this.store.data.affairList = newAffairList;
      this.store.data.separateIndex = separate;

      this.update();
      this.setData({
        "loading.dynamic": false
      });
      // 设置已读
      setRead(id).then(res => {
        this.$store.data.isIndexAffairListNeedUpdate = true;
        this.update();
      });
    })
  },

  // 获取所有的任务和文件
  getTaskAndFiles(affairList) {
    const files = [];
    const tasks = [];
    affairList.forEach(it => {
      if (it.commentType === 'task') {
        tasks.push(it)
      } else if (it.commentType === 'file') {
        if (!it.fileDetailList) {
          return
        }
        for (let i = 0; i < it.fileDetailList.length; i++) {
          files.push(it.fileDetailList[i])
        }
      }
    })
    this.store.data.files = files;
    this.store.data.tasks = tasks;
    this.update();
  },
  //处理会议动态数据
  dealAffairData(affairList) {
    let separate = -1;
    affairList.forEach((it, index) => {
      if (it.readFlag === 0) {
        separate = index;
      }
      if (it.createTime) {
        it.updateTime = getCreateShowTime(it.updateTime);
      }
      if (it.notes) {
        it.notes = removeHtml(it.notes);
      }
      if (it.replyCommentList) {
        it.replyCommentList.map(item => {
          item.updateTime = getCreateShowTime(item.updateTime);
        })
      }
    })
    separate = fixSeperateIndex(separate, affairList);

    return [affairList, separate]
  },
  // 上传文件
  async handleAddFile() {

    this.store.data.description = '';
    this.store.data.fileInfos = null;
    const res = await getFileInfo();
    dd.hideLoading()
    if (res.code === -1) {
      dd.alert({
        content: res.msg,
        buttonText: '确定'
      })
      return
    }
    let data = []
    res.data.map(it => {
      data.push({
        fileId: it.fileId,
        name: it.fileName,
        size: it.fileSize,
        spaceId: it.spaceId,
        platform: "dingTalk",
        mimeType: it.fileType
      })
    })

    this.store.data.fileInfos = data
    this.update()
    dd.navigateTo({ url: `./../uploadFile/uploadFile?id=${this.store.data.scheduleId}` })
  },
  expand() {
    this.setData({
      isExpand: false
    })
  },
  //修改任务状态
  changeTaskStatus(e) {
    this.store.changeStatus(this.store.data.scheduleId, {
      commentId: e.commentId,
      processState: e.status,
      taskId: e.taskId
    }, () => {
      dd.pageScrollTo({
        scrollTop: 0
      })
    });
    this.$store.data.isIndexAffairListNeedUpdate = true;
    this.update();
  },
  // 创建任务
  goCreateTask(e) {
    this.store.data.currentTask = {};
    this.update();
    dd.navigateTo({ url: '/pages/createTask/createTask?meetingId=' + this.store.data.scheduleId })
  },
  editTask(e) {
    const { task, commentId } = e.currentTarget.dataset;
    const executor = (task.executor && task.executor.length > 0) ? task.executor[0] : {}
    this.store.data.currentTask = {
      endTime: task.endTime,
      excutor: executor,
      originExcutor: executor,
      originExcutorId: executor.userId,
      title: task.title,
      excutorId: executor.userId,
      taskId: task.taskId,
      commentId: commentId
    };
    this.store.data.modifyDynamicId = '';
    this.update();
    dd.navigateTo({ url: '/pages/createTask/createTask?meetingId=' + this.store.data.scheduleId + '&type=edit' })
  },
  // 创建会议笔记
  openNoteModal() {
    this.setData({
      popup: {
        show: true,
        title: '创建会议笔记',
        mask: true,
        type: 'notesModal'
      }
    })
  },
  // 编辑笔记
  editNotes(e) {
    this.store.data.notes = e.currentTarget.dataset;
    this.update();
    this.setData({
      popup: {
        show: true,
        title: '编辑会议笔记',
        mask: true,
        type: 'notesModal'
      }
    })
    this.handleCloseOperation()
  },
  getNotes: throttle(function (notes) {
    //编辑
    if (this.store.data.notes) {
      //是否发送通知
      dd.confirm({
        title: '通知',
        content: '是否更新动态列表通知其他成员？',
        confirmButtonText: '通知',
        cancelButtonText: '不通知',
        success: (res) => {
          if (res.confirm) {
            this.updateNotes(notes, true, (index) => {
              const changeData = this.store.data.affairList[index];
              changeData.notes = notes;
              changeData.updateTime = getCreateShowTime(new Date());
              this.store.data.affairList.splice(index, 1);
              this.store.data.affairList.unshift(changeData);
              if (index > this.store.data.separateIndex && this.store.data.separateIndex !== -1) {
                this.store.data.separateIndex += 1;
                this.store.data.separateIndex = fixSeperateIndex(this.store.data.separateIndex, this.store.data.affairList)
              }

              dd.pageScrollTo({
                scrollTop: 0
              })
            })
          } else {
            this.updateNotes(notes, false, (index) => {
              this.store.data.affairList[index].notes = notes;
            })
          }
        }
      })
      return
    }
    //创建
    updateMeetingTask({
      platform: 'dingTalk',
      notice: true,
      meetingId: this.store.data.scheduleId,
      notesModel: {
        meetingNotes: notes
      }
    }).then(res => {
      if (res.data.code == 0) {

        //修改列表数据
        if (res.data.data) {
          const addData = res.data.data[0].commentListDataModelList[0];
          addData.updateTime = getCreateShowTime(addData.updateTime);
          this.store.data.affairList.unshift(addData);
        }

        this.closePopup();

        // 通知更新
        this.$store.data.isIndexAffairListNeedUpdate = true;
        this.update();
      }
    })
  }),
  //更新笔记
  updateNotes(notes, notice, callBack) {
    updateMoment({
      ...this.store.data.notes,
      platform: 'dingTalk',
      notice: notice,
      meetingNotes: notes,
      meetingId: this.store.data.scheduleId
    }).then(res => {
      if (res.data.code == 0) {
        this.closePopup();
        // 修改列表数据
        const [index] = this.getIndexFromAffairList(this.store.data.notes.commentId);
        if (index !== -1) {
          callBack(index);
        }
        // clear
        this.store.data.notes = null;
        this.update();

        // 通知更新
        this.$store.data.isIndexAffairListNeedUpdate = true;
        this.update();
      }
    })
  },
  //添加评论
  openComentModal(e) {
    this.handleCloseOperation()
    this.store.data.parentCommentId = e.currentTarget.dataset.commentId;
    this.update();
    this.setData({
      popup: {
        show: true,
        title: '添加评论',
        mask: true,
        type: 'commentModal'
      }
    })
  },
  getComment(comment) {
    updateMeetingTask({
      parentCommentId: this.store.data.parentCommentId,
      platform: 'dingTalk',
      remark: comment,
      notice: false,
      meetingId: this.store.data.scheduleId,
    }).then(res => {
      if (res.data.code == 0) {

        // 修改列表数据
        const [index] = this.getIndexFromAffairList(this.store.data.parentCommentId);
        if (index !== -1) {
          const addData = res.data.data[0].commentListDataModelList[0];
          addData.updateTime = getCreateShowTime(addData.updateTime);
          if (this.store.data.affairList[index].replyCommentList) {
            this.store.data.affairList[index].replyCommentList.push(addData)
          } else {
            this.store.data.affairList[index].replyCommentList = [addData];
          }
        }
        // clear
        this.store.data.parentCommentId = '';
        this.update();
        this.closePopup();
      }
    })
  },
  // 删除动态
  handleDeleteMoment(e) {

    this.handleCloseOperation()
    this.deleteComment('', e.currentTarget.dataset.commentId)
  },
  // 有commentId删除评论，无则删除动态
  deleteComment(commentId, parentCommentId) {
    dd.confirm({
      title: '删除',
      content: '确认要删除吗？',
      confirmButtonText: '确定',
      cancelButtonText: '取消',
      success: (res) => {
        if (res.confirm) {
          deleteMoment(commentId || parentCommentId).then(res => {
            if (res.data.code === 0) {
              const [index, childIndex] = this.getIndexFromAffairList(parentCommentId, commentId);
              if (commentId) {
                if (childIndex !== -1) {
                  this.store.data.affairList[index].replyCommentList.splice(childIndex, 1);
                }
                this.update();
              } else {
                if (index !== -1) {
                  const deleteData = this.store.data.affairList.splice(index, 1);
                  //删除过往以上的-1
                  if (index <= this.store.data.separateIndex) {
                    this.store.data.separateIndex -= 1;
                  } else {
                    this.store.data.separateIndex = fixSeperateIndex(this.store.data.separateIndex, this.store.data.affairList);
                  }

                  this.update();
                  // 如果删除的动态包含文件和任务，需要修改
                  if (deleteData[0].fileDetailList || deleteData[0].meetingTaskSimpleViewModel) {
                    this.getTaskAndFiles(this.store.data.affairList);
                  }
                  // 通知更新
                  this.$store.data.isIndexAffairListNeedUpdate = true;
                  this.update();
                }
              }
            }
          })
        }
      }
    })
  },
  //修改描述
  openRemarkModal(e) {
    this.store.data.remark = e.currentTarget.dataset;
    this.update();
    this.setData({
      popup: {
        show: true,
        title: '添加描述',
        mask: true,
        type: 'remarkModal'
      }
    });
    this.handleCloseOperation();
  },
  getRemark(remark) {
    //是否发送通知
    dd.confirm({
      title: '通知',
      content: '是否更新动态列表通知其他成员？',
      confirmButtonText: '通知',
      cancelButtonText: '不通知',
      success: (res) => {
        if (res.confirm) {
          this.updateRemark(remark, true, (index) => {
            const changeData = this.store.data.affairList[index];
            changeData.remark = remark;
            changeData.updateTime = getCreateShowTime(new Date());
            this.store.data.affairList.splice(index, 1);
            this.store.data.affairList.unshift(changeData);
            if (index > this.store.data.separateIndex && this.store.data.separateIndex !== -1) {
              this.store.data.separateIndex += 1;
              this.store.data.separateIndex = fixSeperateIndex(this.store.data.separateIndex, this.store.data.affairList)
            }

            dd.pageScrollTo({
              scrollTop: 0
            })
          })
        } else {
          this.updateRemark(remark, false, (index) => {
            this.store.data.affairList[index].remark = remark;
          })
        }
      }
    })
  },
  updateRemark(remark, notice, callBack) {
    const commentId = this.store.data.remark.commentId;
    updateMoment({
      commentId,
      remark,
      platform: 'dingTalk',
      notice: notice,
    }).then(res => {
      if (res.data.code == 0) {
        this.closePopup();
        const [index] = this.getIndexFromAffairList(commentId);
        if (index !== -1) {
          callBack(index);
        }
        // clear
        this.store.data.remark = null;
        this.update();

        // 通知更新
        this.$store.data.isIndexAffairListNeedUpdate = true;
        this.update();
      }
    })
  },
  getIndexFromAffairList(parentCommentId, commentId) {
    const index = this.store.data.affairList.findIndex(it => it.commentId === parentCommentId);
    let childIndex = -1;
    if (index !== -1) {
      if (commentId) {
        childIndex = this.store.data.affairList[index].replyCommentList.findIndex(it => it.commentId === commentId)
      }
    }
    return [index, childIndex];
  },
  goTasksPage() {
    dd.navigateTo({ url: '/pages/tasks/tasks?meetingId=' + this.store.data.scheduleId })
  },
  goFilesPage() {
    dd.navigateTo({ url: '/pages/files/files?meetingId=' + this.store.data.scheduleId })
  },
  // 打开修改弹窗
  handleOpenOperation(event) {
    this.store.data.modifyDynamicId = event.currentTarget.dataset.commentId
    this.update()
  },
  // 关闭修改弹窗
  handleCloseOperation() {
    if (!this.store.data.modifyDynamicId) {
      return
    }
    this.store.data.modifyDynamicId = ''
    this.update()
  },
  // 图片加载完成
  imageLoad(event) {
    // debugger

  },

  blank() {
    // debugger
  },


});


export function fixSeperateIndex(index, list) {

  let separate = index;
  if (list.length == 0) {
    return -1;

  }
  if (separate === list.length - 1) {
    separate = -1;
  }
  if (list[list.length - 1].commentType === 'meeting') {
    if (separate === list.length - 2) {
      separate = -1;
    }
  }
  return separate;
}