import {
  getReserveRoomList,
  getAllScheduleWithMeetingRoomByTime,
  getRoomTree
} from "../../api/request";
import { EEXIST } from "constants";
import { getFormatDate, padZero } from "../../utils/utils";
import { getFlatTree } from "../../utils/flatTree.js";
import create from "dd-store";
create.Page({
  data: {
    $data: null,
    isShowCalendar: false,
    equipFacilityList: [],
    reserveRoomList: [],
    lableTreeList: [],
    timeListStr: [
      0,
      1,
      2,
      3,
      4,
      5,
      6,
      7,
      8,
      9,
      10,
      11,
      12,
      13,
      14,
      15,
      16,
      17,
      18,
      19,
      20,
      21,
      22,
      23
    ],
    search: {
      category: "",
      locationName: "全部区域",
      locationId: "",
      time: ""
    },
    modalFooter: {
      startTime: "",
      endTime: "",
      allMinutes: "",
      isOneDay: true
    },
    dataNum: "0",
    noRoom: false,
    isShowModal: false,
    modalList: [],
    meetingTime: {
      startTime: "",
      endTime: "",
      date: "",
      meetingRoomId: "",
      meetingRoomName: ""
    },
    canScroll: true,
    toThisTime: "",
    TimeSlot: {
      todayTime: "",
      tomorrowTime: "",
      afterTomorrowTime: "",
      customTime: ""
    },
    userId: "",
    areaMap: null
  },
  parentStr: "",
  onLoad(query) {
    let date = new Date(this.$store.data.startTime.replace(/-/g, "/"));
    let year = date.getFullYear();
    let month = padZero(date.getMonth() + 1);
    let day = padZero(date.getDate());
    let toDayDate = new Date();
    let tomorrowTime = new Date(toDayDate);
    tomorrowTime.setDate(tomorrowTime.getDate() + 1);
    let afterTomorrowTime = new Date(toDayDate);
    afterTomorrowTime.setDate(afterTomorrowTime.getDate() + 2);
    this.setData({
      "search.time": `${year}-${month}-${day}`,
      "TimeSlot.todayTime": `${toDayDate.getFullYear()}/${padZero(
        toDayDate.getMonth() + 1
      )}/${padZero(toDayDate.getDate())}`,
      "TimeSlot.tomorrowTime": `${tomorrowTime.getFullYear()}/${padZero(
        tomorrowTime.getMonth() + 1
      )}/${padZero(tomorrowTime.getDate())}`,
      "TimeSlot.afterTomorrowTime": `${afterTomorrowTime.getFullYear()}/${padZero(
        afterTomorrowTime.getMonth() + 1
      )}/${padZero(afterTomorrowTime.getDate())}`,
      userId: getApp().globalData.userid
    });
    getRoomTree().then(res => {
      this.setData({
        areaMap: getFlatTree(res.data.data)
      });
      this.getPageData();
      //  console.log(this.data.areaMap)
    });
  },
  onShow() {
    this.update();
  },
  getPageData() {
    let data = {
      startTime: this.data.search.time,
      locationId: ""
    };
    getReserveRoomList(data).then(res => {
      if (res.data.data) {
        for (let value of res.data.data) {
          value.name = `${this.getParentStr(value.locationId)}${value.name}`;
          this.parentStr = "";
        }
        let reserveRoomList = res.data.data.map(item => {
          let startTime = parseInt(
            item.timeSlotWithMeetingVOS[0].reserveStartTime.substring(0, 2)
          );
          let endTime = parseInt(
            item.timeSlotWithMeetingVOS[
              item.timeSlotWithMeetingVOS.length - 1
            ].reserveEndTime.substring(0, 2)
          );
          let timeList = [];
          for (let i = startTime; i < endTime; i++) {
            timeList.push(i);
          }
          return {
            ...item,
            timeList
          };
        });
        this.setData({
          reserveRoomList: reserveRoomList,
          noRoom: false
        });
      } else {
        this.setData({
          noRoom: true
        });
      }
    });
  },
  selectSearchTime() {
    let that = this;
    dd.datePicker({
      format: "yyyy-MM-dd",
      currentDate: this.data.search.time,
      success: res => {
        if (res !== {}) {
          that.setData(
            {
              "search.time": res.date
            },
            () => {
              that.getRoomList();
            }
          );
        }
      },
      complete: res => {
        // res
      }
    });
  },
  // 获取当前id 的祖先
  getParentStr(parentId) {
    if (parentId !== "0" && this.data.areaMap.get(parentId)) {
      // if ()) {
      //   return this.parentStr
      // }
      this.parentStr =
        this.data.areaMap.get(parentId).name + "-" + this.parentStr;
      // 此处一定return
      return this.getParentStr(this.data.areaMap.get(parentId).parentId);
    } else {
      let parentStr = this.parentStr;
      return parentStr;
    }
  },
  // 弹出modal选择会议时间
  changeRoomTime(e) {
    let that = this;
    let roomId = e.currentTarget.dataset.roomid;
    let dateTime = this.data.search.time;
    let modalDate = new Date();
    let modalMins = modalDate.getMinutes();
    let modalHour =
      modalMins < 30
        ? modalDate.getHours() < 10
          ? "0" + modalDate.getHours()
          : modalDate.getHours()
        : modalDate.getHours() + 1 < 10
          ? "0" + (modalDate.getHours() + 1)
          : modalDate.getHours() + 1;
    let num = "";
    if (dateTime.replace(/-/g, "/") === this.data.TimeSlot.todayTime) {
      num = "0";
    } else if (
      dateTime.replace(/-/g, "/") === this.data.TimeSlot.tomorrowTime
    ) {
      num = "1";
    } else if (
      dateTime.replace(/-/g, "/") === this.data.TimeSlot.afterTomorrowTime
    ) {
      num = "2";
    } else {
      num = "3";
    }
    this.setData({
      "meetingTime.date": dateTime.replace(/-/g, "/"),
      "meetingTime.meetingRoomId": e.currentTarget.dataset.roomid,
      "meetingTime.meetingRoomName": e.currentTarget.dataset.roomname,
      dataNum: num
    });
    let data = {
      meetingRoomId: roomId,
      startTime: dateTime
    };
    getReserveRoomList(data).then(res => {
      let modalList = res.data.data[0].timeSlotWithMeetingVOS.map(item => {
        // 判断是否过期
        if (
          item.reserveStatus === "expired" ||
          item.reserveStatus === "occupied"
        ) {
          return {
            ...item,
            status: "BeOverdue",
            reserveStartTime: `${dateTime} ${item.reserveStartTime}`,
            reserveEndTime: `${dateTime} ${item.reserveEndTime}`
          };
        } else {
          return {
            ...item,
            status: "Uncheck",
            reserveStartTime: `${dateTime} ${item.reserveStartTime}`,
            reserveEndTime: `${dateTime} ${item.reserveEndTime}`
          };
        }
      });
      that.setData(
        {
          toThisTime: ""
        },
        () => {
          that.setData({
            modalList: modalList,
            isShowModal: true,
            canScroll: false,
            toThisTime: `${modalHour}:${modalMins < 30 ? "30" : "00"}`
          });
        }
      );
    });
  },
  // 修改弹框checkBox
  onChangeModalTime(e) {
    let that = this;
    let index = e.currentTarget.dataset.index;
    let data = this.data.modalList[index]; // 点击的数据
    if (data.status === "BeOverdue") {
      return false;
    }
    if (!this.data.meetingTime.startTime && !this.data.meetingTime.endTime) {
      // 判断是否有开始时间
      console.log("判断是否有开始时间");
      let listStr = `modalList[${index}].status`;
      let modalFooterTime = new Date(data.reserveStartTime.replace(/-/g, "/"));
      modalFooterTime.setMinutes(modalFooterTime.getMinutes() + 30);
      this.setData({
        "meetingTime.startTime": data.reserveStartTime,
        [listStr]: "checked",
        "modalFooter.startTime": data.reserveStartTime,
        "modalFooter.endTime": `${modalFooterTime.getFullYear()}-${
          modalFooterTime.getMonth() < 9
            ? "0" + (modalFooterTime.getMonth() + 1)
            : modalFooterTime.getMonth() + 1
          }-${
          modalFooterTime.getDate() < 10
            ? "0" + modalFooterTime.getDate()
            : modalFooterTime.getDate()
          } ${
          modalFooterTime.getHours() < 10
            ? "0" + modalFooterTime.getHours()
            : modalFooterTime.getHours()
          }:${
          modalFooterTime.getMinutes() < 10
            ? "0" + modalFooterTime.getMinutes()
            : modalFooterTime.getMinutes()
          }`,
        "modalFooter.allMinutes": 30,
        "modalFooter.isOneDay": true
      });
    } else if (
      this.data.meetingTime.startTime &&
      !this.data.meetingTime.endTime
    ) {
      // 判断有开时间，没有结束时间
      if (this.data.meetingTime.startTime === data.reserveStartTime) {
        // 点击的同一个checkBox
        let listStr = `modalList[${index}].status`;
        this.setData({
          "meetingTime.startTime": "",
          [listStr]: "Uncheck",
          "modalFooter.startTime": data.reserveStartTime,
          "modalFooter.endTime": "",
          "modalFooter.allMinutes": "",
          "modalFooter.isOneDay": true
        });
        console.log("2.1");
      } else if (
        new Date(this.data.meetingTime.startTime.replace(/-/g, "/")).getTime() >
        new Date(data.reserveStartTime.replace(/-/g, "/")).getTime()
      ) {
        //比已选时间小
        console.log("2.2");
        if (
          this.isDaySpan(
            this.data.meetingTime.startTime.replace(/-/g, "/"),
            data.reserveStartTime.replace(/-/g, "/")
          )
        ) {
          //非跨天
          if (
            this.isOptional(
              data.reserveStartTime,
              this.data.meetingTime.startTime
            )
          ) {
            let modalFooterTime = new Date(
              that.data.meetingTime.startTime.replace(/-/g, "/")
            );
            modalFooterTime.setMinutes(modalFooterTime.getMinutes() + 30);
            let allMinutes =
              (modalFooterTime -
                new Date(data.reserveStartTime.replace(/-/g, "/")).getTime()) /
              60000;
            this.setData(
              {
                "meetingTime.startTime": data.reserveStartTime,
                "meetingTime.endTime": that.data.meetingTime.startTime,
                "modalFooter.startTime": data.reserveStartTime,
                "modalFooter.endTime": `${modalFooterTime.getFullYear()}-${
                  modalFooterTime.getMonth() < 9
                    ? "0" + (modalFooterTime.getMonth() + 1)
                    : modalFooterTime.getMonth() + 1
                  }-${
                  modalFooterTime.getDate() < 10
                    ? "0" + modalFooterTime.getDate()
                    : modalFooterTime.getDate()
                  } ${
                  modalFooterTime.getHours() < 10
                    ? "0" + modalFooterTime.getHours()
                    : modalFooterTime.getHours()
                  }:${
                  modalFooterTime.getMinutes() < 10
                    ? "0" + modalFooterTime.getMinutes()
                    : modalFooterTime.getMinutes()
                  }`,
                "modalFooter.allMinutes": allMinutes,
                "modalFooter.isOneDay": true
              },
              () => {
                that.refreshModalList();
              }
            );
          } else {
            console.log("已有会议，不可点击");
          }
        } else {
          //跨天
          this.getAllScheduleWithMeetingRoomByTime(
            data.reserveStartTime,
            this.data.meetingTime.startTime
          ).then(res => {
            if (res) {
              let modalFooterTime = new Date(
                that.data.meetingTime.startTime.replace(/-/g, "/")
              );
              modalFooterTime.setMinutes(modalFooterTime.getMinutes() + 30);
              let allMinutes =
                (modalFooterTime -
                  new Date(
                    data.reserveStartTime.replace(/-/g, "/")
                  ).getTime()) /
                60000;
              that.setData(
                {
                  "meetingTime.startTime": data.reserveStartTime,
                  "meetingTime.endTime": that.data.meetingTime.startTime,
                  "modalFooter.startTime": data.reserveStartTime,
                  "modalFooter.endTime": `${modalFooterTime.getFullYear()}-${
                    modalFooterTime.getMonth() < 9
                      ? "0" + (modalFooterTime.getMonth() + 1)
                      : modalFooterTime.getMonth() + 1
                    }-${
                    modalFooterTime.getDate() < 10
                      ? "0" + modalFooterTime.getDate()
                      : modalFooterTime.getDate()
                    } ${
                    modalFooterTime.getHours() < 10
                      ? "0" + modalFooterTime.getHours()
                      : modalFooterTime.getHours()
                    }:${
                    modalFooterTime.getMinutes() < 10
                      ? "0" + modalFooterTime.getMinutes()
                      : modalFooterTime.getMinutes()
                    }`,
                  "modalFooter.allMinutes": allMinutes,
                  "modalFooter.isOneDay": false
                },
                () => {
                  that.refreshModalList();
                }
              );
            } else {
              dd.alert({
                content: "会议室已被占用",
                buttonText: "确定"
              });
            }
          });
        }
      } else {
        //比已选时间大
        console.log("2.3");
        if (
          this.isDaySpan(
            this.data.meetingTime.startTime.replace(/-/g, "/"),
            data.reserveStartTime.replace(/-/g, "/")
          )
        ) {
          // 非跨天
          if (
            this.isOptional(
              this.data.meetingTime.startTime,
              data.reserveStartTime
            )
          ) {
            let modalFooterTime = new Date(
              data.reserveStartTime.replace(/-/g, "/")
            );
            modalFooterTime.setMinutes(modalFooterTime.getMinutes() + 30);
            let allMinutes =
              (modalFooterTime -
                new Date(
                  that.data.meetingTime.startTime.replace(/-/g, "/")
                ).getTime()) /
              60000;
            this.setData(
              {
                "meetingTime.endTime": data.reserveStartTime,
                "modalFooter.startTime": that.data.meetingTime.startTime,
                "modalFooter.endTime": `${modalFooterTime.getFullYear()}-${
                  modalFooterTime.getMonth() < 9
                    ? "0" + (modalFooterTime.getMonth() + 1)
                    : modalFooterTime.getMonth() + 1
                  }-${
                  modalFooterTime.getDate() < 10
                    ? "0" + modalFooterTime.getDate()
                    : modalFooterTime.getDate()
                  } ${
                  modalFooterTime.getHours() < 10
                    ? "0" + modalFooterTime.getHours()
                    : modalFooterTime.getHours()
                  }:${
                  modalFooterTime.getMinutes() < 10
                    ? "0" + modalFooterTime.getMinutes()
                    : modalFooterTime.getMinutes()
                  }`,
                "modalFooter.allMinutes": allMinutes,
                "modalFooter.isOneDay": true
              },
              () => {
                that.refreshModalList();
              }
            );
          } else {
            console.log("已有会议");
          }
        } else {
          // 跨天
          this.getAllScheduleWithMeetingRoomByTime(
            data.reserveStartTime,
            this.data.meetingTime.startTime
          ).then(res => {
            if (res) {
              let modalFooterTime = new Date(
                data.reserveStartTime.replace(/-/g, "/")
              );
              modalFooterTime.setMinutes(modalFooterTime.getMinutes() + 30);
              let allMinutes =
                (modalFooterTime -
                  new Date(
                    that.data.meetingTime.startTime.replace(/-/g, "/")
                  ).getTime()) /
                60000;
              this.setData(
                {
                  "meetingTime.endTime": data.reserveStartTime,
                  "modalFooter.startTime": that.data.meetingTime.startTime,
                  "modalFooter.endTime": `${modalFooterTime.getFullYear()}-${
                    modalFooterTime.getMonth() < 9
                      ? "0" + (modalFooterTime.getMonth() + 1)
                      : modalFooterTime.getMonth() + 1
                    }-${
                    modalFooterTime.getDate() < 10
                      ? "0" + modalFooterTime.getDate()
                      : modalFooterTime.getDate()
                    } ${
                    modalFooterTime.getHours() < 10
                      ? "0" + modalFooterTime.getHours()
                      : modalFooterTime.getHours()
                    }:${
                    modalFooterTime.getMinutes() < 10
                      ? "0" + modalFooterTime.getMinutes()
                      : modalFooterTime.getMinutes()
                    }`,
                  "modalFooter.allMinutes": allMinutes,
                  "modalFooter.isOneDay": false
                },
                () => {
                  that.refreshModalList();
                }
              );
            } else {
              dd.alert({
                content: "会议室已被占用",
                buttonText: "确定"
              });
            }
          });
        }
      }
    } else if (
      this.data.meetingTime.startTime &&
      this.data.meetingTime.endTime
    ) {
      //判断有开始时间和结束时间
      if (this.data.meetingTime.startTime === data.reserveStartTime) {
        //开始时间等于点击的开始时间，取消第一个的操作
        console.log("3.1");
        let startTimeDate = new Date(
          this.data.meetingTime.startTime.replace(/-/g, "/")
        );
        startTimeDate.setMinutes(startTimeDate.getMinutes() + 30);
        let meetingStartTime = `${startTimeDate.getFullYear()}-${
          startTimeDate.getMonth() + 1 < 10
            ? "0" + (startTimeDate.getMonth() + 1)
            : startTimeDate.getMonth() + 1
          }-${
          startTimeDate.getDate() < 10
            ? "0" + startTimeDate.getDate()
            : startTimeDate.getDate()
          } ${
          startTimeDate.getHours() < 10
            ? "0" + startTimeDate.getHours()
            : startTimeDate.getHours()
          }:${
          startTimeDate.getMinutes() < 10
            ? "0" + startTimeDate.getMinutes()
            : startTimeDate.getMinutes()
          }`;
        if (meetingStartTime === this.data.meetingTime.endTime) {
          let modalFooterTime = new Date(
            that.data.meetingTime.endTime.replace(/-/g, "/")
          );
          modalFooterTime.setMinutes(modalFooterTime.getMinutes() + 30);
          this.setData(
            {
              "meetingTime.startTime": meetingStartTime,
              "meetingTime.endTime": "",
              "modalFooter.startTime": meetingStartTime,
              "modalFooter.endTime": `${modalFooterTime.getFullYear()}-${
                modalFooterTime.getMonth() < 9
                  ? "0" + (modalFooterTime.getMonth() + 1)
                  : modalFooterTime.getMonth() + 1
                }-${
                modalFooterTime.getDate() < 10
                  ? "0" + modalFooterTime.getDate()
                  : modalFooterTime.getDate()
                } ${
                modalFooterTime.getHours() < 10
                  ? "0" + modalFooterTime.getHours()
                  : modalFooterTime.getHours()
                }:${
                modalFooterTime.getMinutes() < 10
                  ? "0" + modalFooterTime.getMinutes()
                  : modalFooterTime.getMinutes()
                }`,
              "modalFooter.allMinutes": 30,
              "modalFooter.isOneDay": true
            },
            () => {
              that.refreshModalList();
            }
          );
        } else {
          let modalFooterTime = new Date(
            that.data.meetingTime.endTime.replace(/-/g, "/")
          );
          modalFooterTime.setMinutes(modalFooterTime.getMinutes() + 30);
          let allMinutes =
            (modalFooterTime -
              new Date(meetingStartTime.replace(/-/g, "/")).getTime()) /
            60000;
          this.setData(
            {
              "meetingTime.startTime": meetingStartTime,
              "modalFooter.startTime": meetingStartTime,
              "modalFooter.endTime": `${modalFooterTime.getFullYear()}-${
                modalFooterTime.getMonth() < 9
                  ? "0" + (modalFooterTime.getMonth() + 1)
                  : modalFooterTime.getMonth() + 1
                }-${
                modalFooterTime.getDate() < 10
                  ? "0" + modalFooterTime.getDate()
                  : modalFooterTime.getDate()
                } ${
                modalFooterTime.getHours() < 10
                  ? "0" + modalFooterTime.getHours()
                  : modalFooterTime.getHours()
                }:${
                modalFooterTime.getMinutes() < 10
                  ? "0" + modalFooterTime.getMinutes()
                  : modalFooterTime.getMinutes()
                }`,
              "modalFooter.allMinutes": allMinutes
            },
            () => {
              that.refreshModalList();
            }
          );
        }
      } else if (this.data.meetingTime.endTime === data.reserveStartTime) {
        //开始时间等于点击的结束时间，取消最后一个的操作
        console.log("3.2");
        let endTimeDate = new Date(
          this.data.meetingTime.endTime.replace(/-/g, "/")
        );
        endTimeDate.setMinutes(endTimeDate.getMinutes() - 30);
        let meetingEndTime = `${endTimeDate.getFullYear()}-${
          endTimeDate.getMonth() + 1 < 10
            ? "0" + (endTimeDate.getMonth() + 1)
            : endTimeDate.getMonth() + 1
          }-${
          endTimeDate.getDate() < 10
            ? "0" + endTimeDate.getDate()
            : endTimeDate.getDate()
          } ${
          endTimeDate.getHours() < 10
            ? "0" + endTimeDate.getHours()
            : endTimeDate.getHours()
          }:${
          endTimeDate.getMinutes() < 10
            ? "0" + endTimeDate.getMinutes()
            : endTimeDate.getMinutes()
          }`;
        if (meetingEndTime === this.data.meetingTime.startTime) {
          let modalFooterTime = new Date(
            this.data.meetingTime.startTime.replace(/-/g, "/")
          );
          modalFooterTime.setMinutes(modalFooterTime.getMinutes() + 30);
          this.setData(
            {
              "meetingTime.endTime": "",
              "modalFooter.startTime": that.data.meetingTime.startTime,
              "modalFooter.endTime": `${modalFooterTime.getFullYear()}-${
                modalFooterTime.getMonth() < 9
                  ? "0" + (modalFooterTime.getMonth() + 1)
                  : modalFooterTime.getMonth() + 1
                }-${
                modalFooterTime.getDate() < 10
                  ? "0" + modalFooterTime.getDate()
                  : modalFooterTime.getDate()
                } ${
                modalFooterTime.getHours() < 10
                  ? "0" + modalFooterTime.getHours()
                  : modalFooterTime.getHours()
                }:${
                modalFooterTime.getMinutes() < 10
                  ? "0" + modalFooterTime.getMinutes()
                  : modalFooterTime.getMinutes()
                }`,
              "modalFooter.allMinutes": 30
            },
            () => {
              that.refreshModalList();
            }
          );
        } else {
          let modalFooterTime = new Date(meetingEndTime.replace(/-/g, "/"));
          modalFooterTime.setMinutes(modalFooterTime.getMinutes() + 30);
          let allMinutes =
            (modalFooterTime -
              new Date(
                that.data.meetingTime.startTime.replace(/-/g, "/")
              ).getTime()) /
            60000;
          this.setData(
            {
              "meetingTime.endTime": meetingEndTime,
              "modalFooter.startTime": that.data.meetingTime.startTime,
              "modalFooter.endTime": `${modalFooterTime.getFullYear()}-${
                modalFooterTime.getMonth() < 9
                  ? "0" + (modalFooterTime.getMonth() + 1)
                  : modalFooterTime.getMonth() + 1
                }-${
                modalFooterTime.getDate() < 10
                  ? "0" + modalFooterTime.getDate()
                  : modalFooterTime.getDate()
                } ${
                modalFooterTime.getHours() < 10
                  ? "0" + modalFooterTime.getHours()
                  : modalFooterTime.getHours()
                }:${
                modalFooterTime.getMinutes() < 10
                  ? "0" + modalFooterTime.getMinutes()
                  : modalFooterTime.getMinutes()
                }`,
              "modalFooter.allMinutes": allMinutes
            },
            () => {
              that.refreshModalList();
            }
          );
        }
      } else if (
        new Date(this.data.meetingTime.startTime.replace(/-/g, "/")).getTime() >
        new Date(data.reserveStartTime.replace(/-/g, "/")).getTime()
      ) {
        //比已选时间小
        console.log("3.3");
        // 判断是否跨天
        if (
          this.isDaySpan(
            this.data.meetingTime.startTime.replace(/-/g, "/"),
            data.reserveStartTime.replace(/-/g, "/")
          )
        ) {
          // 非跨天
          if ((data.reserveStartTime, this.data.meetingTime.startTime)) {
            let modalFooterTime = new Date(
              that.data.meetingTime.endTime.replace(/-/g, "/")
            );
            modalFooterTime.setMinutes(modalFooterTime.getMinutes() + 30);
            let allMinutes =
              (modalFooterTime -
                new Date(data.reserveStartTime.replace(/-/g, "/")).getTime()) /
              60000;
            this.setData(
              {
                "meetingTime.startTime": data.reserveStartTime,
                "modalFooter.startTime": data.reserveStartTime,
                "modalFooter.endTime": `${modalFooterTime.getFullYear()}-${
                  modalFooterTime.getMonth() < 9
                    ? "0" + (modalFooterTime.getMonth() + 1)
                    : modalFooterTime.getMonth() + 1
                  }-${
                  modalFooterTime.getDate() < 10
                    ? "0" + modalFooterTime.getDate()
                    : modalFooterTime.getDate()
                  } ${
                  modalFooterTime.getHours() < 10
                    ? "0" + modalFooterTime.getHours()
                    : modalFooterTime.getHours()
                  }:${
                  modalFooterTime.getMinutes() < 10
                    ? "0" + modalFooterTime.getMinutes()
                    : modalFooterTime.getMinutes()
                  }`,
                "modalFooter.allMinutes": allMinutes,
                "modalFooter.isOneDay": true
              },
              () => {
                that.refreshModalList();
              }
            );
          }
        } else {
          // 跨天
          this.getAllScheduleWithMeetingRoomByTime(
            data.reserveStartTime,
            this.data.meetingTime.startTime
          ).then(res => {
            if (res) {
              let modalFooterTime = new Date(
                that.data.meetingTime.endTime.replace(/-/g, "/")
              );
              modalFooterTime.setMinutes(modalFooterTime.getMinutes() + 30);
              let allMinutes =
                (modalFooterTime -
                  new Date(
                    data.reserveStartTime.replace(/-/g, "/")
                  ).getTime()) /
                60000;
              this.setData(
                {
                  "meetingTime.startTime": data.reserveStartTime,
                  "modalFooter.startTime": data.reserveStartTime,
                  "modalFooter.endTime": `${modalFooterTime.getFullYear()}-${
                    modalFooterTime.getMonth() < 9
                      ? "0" + (modalFooterTime.getMonth() + 1)
                      : modalFooterTime.getMonth() + 1
                    }-${
                    modalFooterTime.getDate() < 10
                      ? "0" + modalFooterTime.getDate()
                      : modalFooterTime.getDate()
                    } ${
                    modalFooterTime.getHours() < 10
                      ? "0" + modalFooterTime.getHours()
                      : modalFooterTime.getHours()
                    }:${
                    modalFooterTime.getMinutes() < 10
                      ? "0" + modalFooterTime.getMinutes()
                      : modalFooterTime.getMinutes()
                    }`,
                  "modalFooter.allMinutes": allMinutes,
                  "modalFooter.isOneDay": false
                },
                () => {
                  that.refreshModalList();
                }
              );
            } else {
              dd.alert({
                content: "会议室已被占用",
                buttonText: "确定"
              });
            }
          });
        }
      } else {
        //比已选时间大直接赋值endTime
        console.log("3.4");
        if (
          this.isDaySpan(
            this.data.meetingTime.startTime.replace(/-/g, "/"),
            data.reserveStartTime.replace(/-/g, "/")
          )
        ) {
          // 非跨天
          if (
            this.isOptional(
              this.data.meetingTime.startTime,
              data.reserveStartTime
            )
          ) {
            //是否可选中
            let modalFooterTime2 = new Date(
              data.reserveStartTime.replace(/-/g, "/")
            );
            modalFooterTime2.setMinutes(modalFooterTime2.getMinutes() + 30);
            let allMinutes =
              (modalFooterTime2 -
                new Date(
                  that.data.meetingTime.startTime.replace(/-/g, "/")
                ).getTime()) /
              60000;
            console.log("3.4.1", allMinutes);
            this.setData(
              {
                "meetingTime.endTime": data.reserveStartTime,
                "modalFooter.startTime": that.data.meetingTime.startTime,
                "modalFooter.endTime": `${modalFooterTime2.getFullYear()}-${
                  modalFooterTime2.getMonth() < 9
                    ? "0" + (modalFooterTime2.getMonth() + 1)
                    : modalFooterTime2.getMonth() + 1
                  }-${
                  modalFooterTime2.getDate() < 10
                    ? "0" + modalFooterTime2.getDate()
                    : modalFooterTime2.getDate()
                  } ${
                  modalFooterTime2.getHours() < 10
                    ? "0" + modalFooterTime2.getHours()
                    : modalFooterTime2.getHours()
                  }:${
                  modalFooterTime2.getMinutes() < 10
                    ? "0" + modalFooterTime2.getMinutes()
                    : modalFooterTime2.getMinutes()
                  }`,
                "modalFooter.allMinutes": allMinutes,
                "modalFooter.isOneDay": true
              },
              () => {
                that.refreshModalList();
              }
            );
          }
        } else {
          // 跨天
          this.getAllScheduleWithMeetingRoomByTime(
            data.reserveStartTime,
            this.data.meetingTime.startTime
          ).then(res => {
            if (res) {
              let modalFooterTime = new Date(
                data.reserveStartTime.replace(/-/g, "/")
              );
              modalFooterTime.setMinutes(modalFooterTime.getMinutes() + 30);
              let allMinutes =
                (modalFooterTime -
                  new Date(
                    that.data.meetingTime.startTime.replace(/-/g, "/")
                  ).getTime()) /
                60000;
              this.setData(
                {
                  "meetingTime.endTime": data.reserveStartTime,
                  "modalFooter.startTime": that.data.meetingTime.startTime,
                  "modalFooter.endTime": `${modalFooterTime.getFullYear()}-${
                    modalFooterTime.getMonth() < 9
                      ? "0" + (modalFooterTime.getMonth() + 1)
                      : modalFooterTime.getMonth() + 1
                    }-${
                    modalFooterTime.getDate() < 10
                      ? "0" + modalFooterTime.getDate()
                      : modalFooterTime.getDate()
                    } ${
                    modalFooterTime.getHours() < 10
                      ? "0" + modalFooterTime.getHours()
                      : modalFooterTime.getHours()
                    }:${
                    modalFooterTime.getMinutes() < 10
                      ? "0" + modalFooterTime.getMinutes()
                      : modalFooterTime.getMinutes()
                    }`,
                  "modalFooter.allMinutes": allMinutes,
                  "modalFooter.isOneDay": false
                },
                () => {
                  that.refreshModalList();
                }
              );
            } else {
              dd.alert({
                content: "会议室已被占用",
                buttonText: "确定"
              });
            }
          });
        }
      }
    }
  },
  // 接口判断跨天会议是否可点击
  getAllScheduleWithMeetingRoomByTime(startTime, endTime) {
    let endTimeDate = new Date(endTime.replace(/-/g, "/"));
    endTimeDate.setMinutes(endTimeDate.getMinutes() + 30);
    let data = {
      meetingRoomId: this.data.meetingTime.meetingRoomId,
      endTime: `${startTime}:00`,
      startTime: `${endTimeDate.getFullYear()}-${
        endTimeDate.getMonth() + 1 < 10
          ? "0" + (endTimeDate.getMonth() + 1)
          : endTimeDate.getMonth() + 1
        }-${
        endTimeDate.getDate() < 10
          ? "0" + endTimeDate.getDate()
          : endTimeDate.getDate()
        } ${
        endTimeDate.getHours() < 10
          ? "0" + endTimeDate.getHours()
          : endTimeDate.getHours()
        }:${
        endTimeDate.getMinutes() < 10
          ? "0" + endTimeDate.getMinutes()
          : endTimeDate.getMinutes()
        }:00`
    };
    return getAllScheduleWithMeetingRoomByTime(data).then(res => {
      return res.data.data;
    });
  },
  // 非跨天会议是否可点击
  isOptional(startTime, endTime) {
    let startTimeMS = new Date(startTime.replace(/-/g, "/")).getTime();
    let endTimeMs = new Date(endTime.replace(/-/g, "/")).getTime();
    let UnDisable = true;
    this.data.modalList.map(item => {
      let itemReserveStartTime = new Date(
        item.reserveStartTime.replace(/-/g, "/")
      ).getTime();
      if (
        itemReserveStartTime >= startTimeMS &&
        itemReserveStartTime <= endTimeMs
      ) {
        if (
          item.reserveStatus === "expired" ||
          item.reserveStatus === "occupied"
        ) {
          UnDisable = false;
        }
      }
    });
    return UnDisable;
  },
  // 更新渲染数据
  refreshModalList() {
    let startTimeMS = new Date(
      this.data.meetingTime.startTime.replace(/-/g, "/")
    ).getTime();
    let endTimeMs = new Date(
      this.data.meetingTime.endTime.replace(/-/g, "/")
    ).getTime();
    let modalList = this.data.modalList.map(item => {
      let itemReserveStartTime = new Date(
        item.reserveStartTime.replace(/-/g, "/")
      ).getTime();
      if (
        itemReserveStartTime === startTimeMS ||
        (itemReserveStartTime >= startTimeMS &&
          itemReserveStartTime <= endTimeMs)
      ) {
        return {
          ...item,
          status: "checked"
        };
      } else {
        if (
          item.reserveStatus === "expired" ||
          item.reserveStatus === "occupied"
        ) {
          return {
            ...item,
            status: "BeOverdue"
          };
        } else {
          return {
            ...item,
            status: "Uncheck"
          };
        }
      }
    });
    this.setData({
      modalList: modalList
    });
  },
  // 是否跨天
  isDaySpan(date1, date2) {
    var date1 = new Date(date1.substr(0, 10));
    var date2 = new Date(date2.substr(0, 10));
    var date =
      (date2.getTime() - date1.getTime()) /
      (1000 * 60 * 60 * 24); /*不用考虑闰年否*/
    return date === 0;
  },
  // 点击今天明天后天
  chooseDate(e) {
    if (e && e.currentTarget.dataset.num == "3") {
      this.setData({
        isShowCalendar: true,
        dataNum: e.currentTarget.dataset.num
      });
    } else {
      this.setData(
        {
          "meetingTime.date":
            e.currentTarget.dataset.num == "0"
              ? this.data.TimeSlot.todayTime
              : e.currentTarget.dataset.num == "1"
                ? this.data.TimeSlot.tomorrowTime
                : this.data.TimeSlot.afterTomorrowTime,
          dataNum: e.currentTarget.dataset.num
        },
        () => {
          this.getTimeSlotData();
        }
      );
    }
  },
  getTimeSlotData() {
    let that = this;
    let modalDate = new Date();
    let modalMins = modalDate.getMinutes();
    let modalHour =
      modalMins < 30
        ? modalDate.getHours() < 10
          ? "0" + modalDate.getHours()
          : modalDate.getHours()
        : modalDate.getHours() + 1 < 10
          ? "0" + (modalDate.getHours() + 1)
          : modalDate.getHours() + 1;
    let selectDate = new Date(this.data.meetingTime.date);
    let meetingDate = `${selectDate.getFullYear()}-${
      selectDate.getMonth() + 1 < 10
        ? "0" + (selectDate.getMonth() + 1)
        : selectDate.getMonth() + 1
      }-${
      selectDate.getDate() < 10
        ? "0" + selectDate.getDate()
        : selectDate.getDate()
      }`;
    let data = {
      meetingRoomId: that.data.meetingTime.meetingRoomId,
      startTime: meetingDate
    };
    getReserveRoomList(data).then(res => {
      const isExpired =
        new Date().getTime() >
        new Date(`${meetingDate.replace(/-/g, "/")} 23:59:59`);
      let modalList = res.data.data[0].timeSlotWithMeetingVOS.map(item => {
        // 判断是否过期
        if (
          item.reserveStatus === "expired" ||
          item.reserveStatus === "occupied" ||
          isExpired
        ) {
          return {
            ...item,
            status: "BeOverdue",
            reserveStartTime: `${meetingDate} ${item.reserveStartTime}`,
            reserveEndTime: `${meetingDate} ${item.reserveEndTime}`
          };
        } else {
          return {
            ...item,
            status: "Uncheck",
            reserveStartTime: `${meetingDate} ${item.reserveStartTime}`,
            reserveEndTime: `${meetingDate} ${item.reserveEndTime}`
          };
        }
      });
      if (this.data.meetingTime.startTime) {
        let startTimeMS = new Date(
          this.data.meetingTime.startTime.replace(/-/g, "/")
        ).getTime();
        let endTimeMs = new Date(
          this.data.meetingTime.endTime.replace(/-/g, "/")
        ).getTime();
        let modalList2 = modalList.map(item => {
          let itemReserveStartTime = new Date(
            item.reserveStartTime.replace(/-/g, "/")
          ).getTime();
          if (
            itemReserveStartTime === startTimeMS ||
            (itemReserveStartTime >= startTimeMS &&
              itemReserveStartTime <= endTimeMs)
          ) {
            return {
              ...item,
              status: "checked"
            };
          } else {
            if (
              item.reserveStatus === "expired" ||
              item.reserveStatus === "occupied"
            ) {
              return {
                ...item,
                status: "BeOverdue"
              };
            } else {
              return {
                ...item,
                status: "Uncheck"
              };
            }
          }
        });
        that.setData({
          modalList: modalList2,
          toThisTime: `${modalHour}:${modalMins < 30 ? "30" : "00"}`
        });
      } else {
        that.setData({
          modalList: modalList,
          toThisTime: `${modalHour}:${modalMins < 30 ? "30" : "00"}`
        });
      }
    });
  },
  onCancel() {
    this.setData({
      isShowModal: false,
      isShowCalendar: false,
      modalList: [],
      meetingTime: {
        startTime: "",
        endTime: "",
        date: "",
        meetingRoomId: ""
      },
      dataNum: 0,
      canScroll: true
    });
  },
  onDetermine() {
    let startTime = this.data.meetingTime.startTime;
    if (startTime && this.data.meetingTime.endTime) {
      var endTimeDate = new Date(
        this.data.meetingTime.endTime.replace(/-/g, "/")
      );
      endTimeDate.setMinutes(endTimeDate.getMinutes() + 30);
      this.$store.data.startTime = `${startTime.replace(/-/g, "/")}:00`;
      this.$store.data.endTime = `${endTimeDate.getFullYear()}/${
        endTimeDate.getMonth() + 1 < 10
          ? "0" + (endTimeDate.getMonth() + 1)
          : endTimeDate.getMonth() + 1
        }/${
        endTimeDate.getDate() < 10
          ? "0" + endTimeDate.getDate()
          : endTimeDate.getDate()
        } ${
        endTimeDate.getHours() < 10
          ? "0" + endTimeDate.getHours()
          : endTimeDate.getHours()
        }:${
        endTimeDate.getMinutes() < 10
          ? "0" + endTimeDate.getMinutes()
          : endTimeDate.getMinutes()
        }:00`;
      this.$store.data.locationName = this.data.meetingTime.meetingRoomName;
      this.$store.data.roomId = this.data.meetingTime.meetingRoomId;
      this.update();
    } else if (startTime) {
      var endTimeDate = new Date(
        this.data.meetingTime.startTime.replace(/-/g, "/")
      );
      endTimeDate.setMinutes(endTimeDate.getMinutes() + 30);
      this.$store.data.startTime = `${startTime.replace(/-/g, "/")}:00`;
      this.$store.data.endTime = `${endTimeDate.getFullYear()}/${
        endTimeDate.getMonth() + 1 < 10
          ? "0" + (endTimeDate.getMonth() + 1)
          : endTimeDate.getMonth() + 1
        }/${
        endTimeDate.getDate() < 10
          ? "0" + endTimeDate.getDate()
          : endTimeDate.getDate()
        } ${
        endTimeDate.getHours() < 10
          ? "0" + endTimeDate.getHours()
          : endTimeDate.getHours()
        }:${
        endTimeDate.getMinutes() < 10
          ? "0" + endTimeDate.getMinutes()
          : endTimeDate.getMinutes()
        }:00`;
      this.$store.data.locationName = this.data.meetingTime.meetingRoomName;
      this.$store.data.roomId = this.data.meetingTime.meetingRoomId;
    }

    if (this.$store.data.originalData && this.$store.data.locationName) {
      if (!this.$store.data.originalData.location) {
        this.$store.data.updateInfo = {
          updateType: "modify_location",
          isUpate: true
        };
        this.update();
      } else if (
        this.$store.data.locationName != this.$store.data.originalData.location.locationName ||
        this.$store.data.roomId != this.$store.data.originalData.meetingRoomId ||
        this.$store.data.startTime != this.$store.data.originalData.startTime.replace(/-/g, "/") ||
        this.$store.data.endTime != this.$store.data.originalData.endTime.replace(/-/g, "/")
      ) {
        this.$store.data.updateInfo = {
          updateType: "modify_location",
          isUpate: true
        };
        this.update();
      }
    }
    // 通知详情页面是否需要重新计算时间
    this.$store.data.shouldUpdateShowTime = true;
    this.update();
    dd.navigateBack({
      delta: 2
    });
  },
  getRoomList() {
    let that = this;
    let data = {
      startTime: that.data.search.time,
      locationId: that.data.search.locationId
    };
    getReserveRoomList(data).then(res => {
      if (res.data.data) {
        for (let value of res.data.data) {
          value.name = `${this.getParentStr(value.locationId)}${value.name}`;
          this.parentStr = "";
        }
        let reserveRoomList = res.data.data.map(item => {
          let startTime = parseInt(
            item.timeSlotWithMeetingVOS[0].reserveStartTime.substring(0, 2)
          );
          let endTime = parseInt(
            item.timeSlotWithMeetingVOS[
              item.timeSlotWithMeetingVOS.length - 1
            ].reserveEndTime.substring(0, 2)
          );
          let timeList = [];
          for (let i = startTime; i < endTime; i++) {
            timeList.push(i);
          }
          return {
            ...item,
            timeList
          };
        });
        that.setData({
          reserveRoomList: reserveRoomList,
          noRoom: false
        });
      } else {
        that.setData({
          reserveRoomList: [],
          noRoom: true
        });
      }
    });
  },
  handleSelect(e) {
    let date = `${e[0].getFullYear()}/${padZero(e[0].getMonth() + 1)}/${padZero(
      e[0].getDate()
    )}`;
    let num = "";
    if (date === this.data.TimeSlot.todayTime) {
      num = "0";
    } else if (date === this.data.TimeSlot.tomorrowTime) {
      num = "1";
    } else if (date === this.data.TimeSlot.afterTomorrowTime) {
      num = "2";
    } else {
      num = "3";
    }
    this.setData(
      {
        isShowCalendar: false,
        "meetingTime.date": date,
        dataNum: num
      },
      () => {
        this.getTimeSlotData();
      }
    );
  },
  onMonthChange() { },
  onYearChange() { },
  onSelectHasDisableDate() {
    my.alert({
      content: "SelectHasDisableDate"
    });
  }
});
